@ECHO OFF

REM     =============================================================
REM                  UPLOAD MAINTAINENCE BATCH FILE V:1.0
REM        BY: GRYMMJACK (SYSOP: SECTOR7 BBS [SECTOR7.DEMONIC.NET])
REM     =============================================================
REM     Below you will find a multitude of environment variables that
REM     this batch file requires you to set per your individual BBS's
REM     configuration/file system. They are explained below...
REM     -------------------------------------------------------------
REM     NOTE: Do NOT include trailing "\" in directory variables!   
REM
REM     FAILLOG     = This is where UPTEST.BAT writes it's error log
REM     ADDDIR      = All files in this dir are added to archive
REM     ZIPCOM      = The path/name of your archive header comment
REM     ARCHID      = The path/name to ARCHID.EXE
REM     OUTTIME     = The path/name to OUTTIME.EXE
REM     WORKDIR     = The path to a working directory.
REM                   NOTE: Must append %2 (for node number) if you
REM                         run a multi-node bbs.
REM     ARCDIR      = The path to your file archiver programs
REM                   (PKZIP.EXE, ARJ.EXE, LHA.EXE, RAR.EXE, etc)
REM     ZIP         = Filename of ZIP program (ex: PKZIP25.EXE)
REM     ARJ         = Filename of ARJ program (ex: ARJ.EXE)
REM     RAR         = Filename of RAR program (ex: RAR.EXE)
REM     LHA         = Filename of LHA program (ex: LHA.EXE)
REM     -------------------------------------------------------------
REM     If you experience ANY trouble with this batch file, odds are
REM     it is related to environment space when your board shells. To
REM     resolve the problem, allocate more memory to the environment:
REM     COMMAND.COM /E=768, etc. or in windows, modify the PIF that
REM     launches your board/wfc/mailer and allocate more memory via
REM     the "Memory" tab in the PIF editor.
REM     =============================================================
REM        ! D O   N O T   A S K   M E    F O R    S U P P O R T !

SET FAILLOG=C:\BBS\LOGS\UPTEST.LOG
SET ADDDIR=C:\BBS\ZIP\*.*
SET ZIPCOM=C:\BBS\ZIPCOM.TXT
SET ARCHID=C:\BBS\ARCS\ARCHID.EXE
SET WORKDIR=D:\FILES\WORK\NODE%2
SET ARCDIR=C:\BBS\ARCS
SET ZIP=PKZIP25.EXE
SET ARJ=ARJ.EXE
SET RAR=RAR.EXE
SET LHA=LHA.EXE

IF "%1" == "" GOTO syntax
IF "%2" == "" GOTO syntax   

IF EXIST %WORKDIR% DELTREE /Y %WORKDIR%\*.* >> NUL
IF NOTEXIST %WORKDIR% MD %WORKDIR% >> NUL

CLS
ECHO ========================================================
ECHO           UPLOAD MAINTAINENCE BATCH FILE V:1.0
ECHO BY: GRYMMJACK (SYSOP: SECTOR7 BBS [SECTOR7.DEMONIC.NET])
ECHO --------------------------------------------------------
ECHO PROCESSING: [%1] (NODE: %2)
ECHO.
ECHO  IDENTIFYING %1 ...

%ARCHID% %1 >> NUL

IF ERRORLEVEL 104 GOTO rar
IF ERRORLEVEL 4 GOTO lha
IF ERRORLEVEL 3 GOTO rar
IF ERRORLEVEL 2 GOTO zip
IF ERRORLEVEL 1 GOTO arj

ECHO  %1 IS NOT A COMPRESSED ARCHIVE!
GOTO end

:arj
ECHO  %1 IS A [ARJ] ARCHIVE!
ECHO  ARJ: ADDING %ADDDIR%...
%ARCDIR%\%ARJ% a -ja1 -e -m0 -jyACDKNORSVY -i -s -y %1 %ADDDIR% >> nul
IF ERRORLEVEL 10 GOTO fail_arj_mem
IF ERRORLEVEL 8 GOTO fail_arj_mem
IF ERRORLEVEL 6 GOTO fail_arj_6
IF ERRORLEVEL 5 GOTO fail_arj_5
IF ERRORLEVEL 4 GOTO fail_arj_4
IF ERRORLEVEL 3 GOTO fail_arj_3
IF ERRORLEVEL 2 GOTO fail_arj_2
IF ERRORLEVEL 0 ECHO  ARJ: SUCCESS!
ECHO  ARJ: COMMENTING %1...          
%ARCDIR%\%ARJ% c %1 -ja1 -jyACDKNORSVY -z%ZIPCOM% >> nul
GOTO done

:fail_arj_mem
ECHO  ARJ: *** FAILURE ***
ECHO  ARJ: MEMORY ERROR
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! ARJ: [%1] FAILURE (10,8) >> %FAILLOG%
ECHO ! ARJ: MEMORY ERROR >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_arj_6
ECHO  ARJ: *** FAILURE ***
ECHO  ARJ: CANNOT OPEN FILE OR ARCHIVE
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! ARJ: [%1] FAILURE (6) >> %FAILLOG%
ECHO ! ARJ: CANNOT OPEN FILE OR ARCHIVE >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_arj_5
ECHO  ARJ: *** FAILURE ***
ECHO  ARJ: DISK FULL / WRITE ERROR      
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! ARJ: [%1] FAILURE (5) >> %FAILLOG%
ECHO ! ARJ: DISK FULL / WRITE ERROR >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_arj_4
ECHO  ARJ: *** FAILURE ***
ECHO  ARJ: SECURITY ERROR (NEED PASSWORD)
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! ARJ: [%1] FAILURE (4) >> %FAILLOG%
ECHO ! ARJ: SECURITY ERROR (NEED PASSWORD) >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_arj_3
ECHO  ARJ: *** FAILURE ***
ECHO  ARJ: CRC ERROR
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! ARJ: [%1] FAILURE (3) >> %FAILLOG%
ECHO ! ARJ: CRC ERROR >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_arj_2
ECHO  ARJ: *** FAILURE ***
ECHO  ARJ: FATAL ERROR
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! ARJ: [%1] FAILURE (2) >> %FAILLOG%
ECHO ! ARJ: FATAL ERROR >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:zip
ECHO  %1 IS A [ZIP] ARCHIVE!
ECHO  ZIP: ADDING %ADDDIR%...
%ARCDIR%\%ZIP% -add -maximum -overwrite -silent %1 %ADDDIR%
IF ERRORLEVEL 153 GOTO fail_zip_153
IF ERRORLEVEL 150 GOTO fail_zip_150
IF ERRORLEVEL 108 GOTO fail_zip_mem
IF ERRORLEVEL 107 GOTO fail_zip_mem
IF ERRORLEVEL 106 GOTO fail_zip_mem
IF ERRORLEVEL 105 GOTO fail_zip_mem
IF ERRORLEVEL 104 GOTO fail_zip_mem
IF ERRORLEVEL 103 GOTO fail_zip_mem
IF ERRORLEVEL 102 GOTO fail_zip_mem
IF ERRORLEVEL 101 GOTO fail_zip_mem
IF ERRORLEVEL 100 GOTO fail_zip_mem
IF ERRORLEVEL 11 GOTO fail_zip_11
IF ERRORLEVEL 2 GOTO fail_zip_2
IF ERRORLEVEL 1 GOTO fail_zip_1
IF ERRORLEVEL 0 ECHO  ZIP: SUCCESS!
ECHO  ZIP: COMMENTING %1...          
%ARCDIR%\%ZIP% -silent -header=@%ZIPCOM% %1 
GOTO done

:fail_zip_153
ECHO  ZIP: *** FAILURE ***
ECHO  ZIP: PREMATURE END OF ZIPFILE
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! ZIP: [%1] FAILURE (153) >> %FAILLOG%
ECHO ! ZIP: PREMATURE END OF ZIPFILE >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_zip_150
ECHO  ZIP: *** FAILURE ***
ECHO  ZIP: UNABLE TO READ ZIPFILE
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! ZIP: [%1] FAILURE (150) >> %FAILLOG%
ECHO ! ZIP: UNABLE TO READ ZIPFILE >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_zip_mem
ECHO  ZIP: *** FAILURE ***
ECHO  ZIP: OUT OF MEMORY
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! ZIP: [%1] FAILURE (108-100) >> %FAILLOG%
ECHO ! ZIP: OUT OF MEMORY >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_zip_11
ECHO  ZIP: *** FAILURE ***
ECHO  ZIP: DISK FULL
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! ZIP: [%1] FAILURE (11) >> %FAILLOG%
ECHO ! ZIP: DISK FULL >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:lha
ECHO  %1 IS A [LHA] ARCHIVE!
ECHO  LHA: ADDING %ADDDIR%...
%ARCDIR%\%LHA% a -n -m %1 %ADDDIR% >> NUL
IF ERRORLEVEL 3 GOTO fail_lha_3
IF ERRORLEVEL 2 GOTO fail_lha_2
IF ERRORLEVEL 1 GOTO fail_lha_1
IF ERRORLEVEL 0 ECHO  LHA: SUCCESS!
ECHO  LHA: ZIP COMMENT UNAVAILABLE!
GOTO done

:fail_lha_3
ECHO  LHA: *** FAILURE ***
ECHO  LHA: FAILED TO CONVERT TEMP FILES TO AN ARCHIVE FILE
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! LHA: [%1] FAILURE (03) >> %FAILLOG%
ECHO ! LHA: FAILED TO CONVERT TEMP FILES TO AN ARCHIVE FILE >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_lha_2
ECHO  LHA: *** FAILURE ***
ECHO  LHA: PROCESS TERMINATED WITHOUT MODIFYING ARCHIVE FILE
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! LHA: [%1] FAILURE (02) >> %FAILLOG%
ECHO ! LHA: PROCESS TERMINATED WITHOUT MODIFYING ARCHIVE >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_lha_1
ECHO  LHA: *** FAILURE ***
ECHO  LHA: FILE EXTRACTION ERROR, CRC ERROR, OR OUT OF DISK SPACE
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! LHA: [%1] FAILURE (01) >> %FAILLOG%
ECHO ! LHA: FILE EXTRACTION ERROR, CRC ERROR, OR OUT OF DISK SPACE >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:rar
ECHO  %1 IS A [RAR] ARCHIVE!
ECHO  RAR: ADDING %ADDDIR%...
%ARCDIR%\%RAR% a -o+ -y -c- -ep -std %1 %ADDDIR% >> NUL
IF ERRORLEVEL 8 GOTO fail_rar_8
IF ERRORLEVEL 6 GOTO fail_rar_6
IF ERRORLEVEL 5 GOTO fail_rar_5
IF ERRORLEVEL 4 GOTO fail_rar_4
IF ERRORLEVEL 3 GOTO fail_rar_3
IF ERRORLEVEL 2 GOTO fail_rar_2
IF ERRORLEVEL 1 GOTO fail_rar_1
ECHO  RAR: COMMENTING %1...
%ARCDIR%\%RAR% c -z%ZIPCOM% -c- %1 < %ZIPCOM% >> NUL
GOTO done

:fail_rar_8
ECHO  RAR: *** FAILURE ***
ECHO  RAR: OUT OF MEMORY
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! RAR: [%1] FAILURE (08) >> %FAILLOG%
ECHO ! OUT OF MEMORY >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_rar_6
ECHO  RAR: *** FAILURE ***
ECHO  RAR: OPEN FILE ERROR
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! RAR: [%1] FAILURE (06) >> %FAILLOG%
ECHO ! OPEN FILE ERROR >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_rar_5
ECHO  RAR: *** FAILURE ***
ECHO  RAR: WRITE ERROR
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! RAR: [%1] FAILURE (05) >> %FAILLOG%
ECHO ! WRITE ERROR >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_rar_4
ECHO  RAR: *** FAILURE ***
ECHO  RAR: LOCKED ARCHIVE
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! RAR: [%1] FAILURE (04) >> %FAILLOG%
ECHO ! LOCKED ARCHIVE >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_rar_3
ECHO  RAR: *** FAILURE ***
ECHO  RAR: CRC ERROR
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! RAR: [%1] FAILURE (03) >> %FAILLOG%
ECHO ! CRC ERROR >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_rar_2
ECHO  RAR: *** FAILURE ***
ECHO  RAR: FATAL ERROR
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! RAR: [%1] FAILURE (08) >> %FAILLOG%
ECHO ! FATAL ERROR >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:fail_rar_1
ECHO  RAR: *** FAILURE ***
ECHO  RAR: NON FATAL ERROR
ECHO  LOGGING FAILURE...          
ECHO. >> %FAILLOG%
outtime >> %FAILLOG%
ECHO ! RAR: [%1] FAILURE (08) >> %FAILLOG%
ECHO ! NON FATAL ERROR >> %FAILLOG%
ECHO. >> %FAILLOG%
GOTO end

:done
ECHO  %1 SUCCESSFULY PROCESSED..
ECHO  EXITING
GOTO end

:syntax
CLS
ECHO ========================================================
ECHO           UPLOAD MAINTAINENCE BATCH FILE V:1.0
ECHO BY: GRYMMJACK (SYSOP: SECTOR7 BBS [SECTOR7.DEMONIC.NET])
ECHO --------------------------------------------------------
ECHO.
ECHO SYNTAX: UPTEST FILENAME.EXT NODE#
ECHO.

:end

